//FractalizeR's AJAX registration extension for VBulletin 3.7+
//Copyright (c) 2008. All rights reserved

$(document).ready(
	function() {
		//#######################################################################################
		PHR_entered_passwords_do_not_match = "Entered passwords do not match!";
		PHR_fill_out_both_password_fields = "Fill out both password fields";
		PHR_password_quality = "Password quality";
			
		//Reading phrases
		$.post(
		'fractalizer_ajaxreg_ajax.php',
		{
			action: "getphrases",
			field: "passwords"
		},
		function(data) {
				PHR_entered_passwords_do_not_match = data.entered_passwords_do_not_match;
				PHR_fill_out_both_password_fields = data.fill_out_both_password_fields;
				PHR_password_quality = data.password_quality;
		}, "json"
		);
	
		//#######################################################################################
		//box_Username part
		box_Username = $("input[name='username']");
		box_Username.bind("blur", validateUsername);
		box_Username.bind("keypress", clearUsernameMarks);
		
		BorderCSS = box_Username.css("border");
		
		//#######################################################################################
		//Passwords part
		box_Password = $("input[name='password']");
		box_PasswordConfirm = $("input[name='passwordconfirm']");
		box_Password.bind("blur", validatePasswords);
		box_Password.bind("keypress", clearPasswordsMarks);
		box_PasswordConfirm.bind("blur", validatePasswords);
		box_PasswordConfirm.bind("keypress", clearPasswordsMarks);
		
		//Attaching button for opening password suggestion window
		passwordTable = box_PasswordConfirm.parent().parent().parent().parent();
		passwordTable.attr("width", parseInt(passwordTable.attr("width"))+50);
		box_PasswordConfirm.after('&nbsp;<a href="#" onClick="window.open(\'fractalizer_ajaxreg_ui.php?do=passwdgenform\', \'new\',\'width=340,height=360,resizable=0\');return false;"><img src="images/ajaxreg/icons/pswsugg.gif" align="baseline" border="0" /></a>');
		box_PasswordConfirm.parent().attr("width", "50%");

		//#######################################################################################
		//Emails part
		box_Email = $("input[name='email']");
		box_EmailConfirm = $("input[name='emailconfirm']");
		box_Email.bind("blur", validateEmails);
		box_Email.bind("keypress", clearEmailsMarks);
		box_EmailConfirm.bind("blur", validateEmails);
		box_EmailConfirm.bind("keypress", clearEmailsMarks);
	}
);

function markErrorneousElement(element, name, message) {
	element.css("border", "1px solid #FF0000");
	$("#FR_ErrorMSG_"+name).remove();
	element.before('<div id="FR_ErrorMSG_'+name+'"><img src="images/ajaxreg/icons/bad.gif"/>&nbsp;'+message+'</div>');
}

function markValidElement(element) {
	element.css("border", "1px solid #00FF00");
}

function validateUsername() {
		clearUsernameMarks();
			$.post(
				'fractalizer_ajaxreg_ajax.php',
				{
					action: "check",
					field: "username",
					value: escape(box_Username.attr("value"))
				},
				function(data) {
					if(data.result!="OK") {
						markErrorneousElement(box_Username, "username", data.message);
					} else {
						markValidElement(box_Username);
					}
				
				}, "json"
			);
}

function clearUsernameMarks() {
	$("#FR_ErrorMSG_username").remove();
	box_Username.css("border", BorderCSS);
}

function validatePasswords() {
	clearPasswordsMarks();

	if((box_Password.attr("value").length<1) || (box_PasswordConfirm.attr("value").length<1)) {
		markErrorneousElement(box_Password, "password", PHR_fill_out_both_password_fields);
		markErrorneousElement(box_PasswordConfirm, "passwordconfirm", PHR_fill_out_both_password_fields);
		return;
	}
	
	if(box_Password.attr("value")!=box_PasswordConfirm.attr("value")) {
		markErrorneousElement(box_Password, "password", PHR_entered_passwords_do_not_match);
		markErrorneousElement(box_PasswordConfirm, "passwordconfirm", PHR_entered_passwords_do_not_match);	
		return;
	}
	
	markValidElement(box_Password);
	markValidElement(box_PasswordConfirm);
	
	box_PasswordConfirm.parent().parent().parent().parent().after('<div id="FR_PasswordStrength">'+PHR_password_quality+'<img src="' + passwordStrengthMeterImg(box_Password.attr("value"))+'" align="absmiddle" />');
	
}

function clearPasswordsMarks() {
	$("#FR_ErrorMSG_password").remove();
	$("#FR_ErrorMSG_passwordconfirm").remove();
	box_Password.css("border", BorderCSS);
	box_PasswordConfirm.css("border", BorderCSS);
	$("#FR_PasswordStrength").remove();
}

function validateEmails() {
			clearEmailsMarks();
			$.post(
				'fractalizer_ajaxreg_ajax.php',
				{
					action: "check",
					field: "emails",
					value1: box_Email.attr("value"),
					value2: box_EmailConfirm.attr("value")
				},
				function(data) {
					if(data.result!="OK") {
						markErrorneousElement(box_Email, "email", data.message);
						markErrorneousElement(box_EmailConfirm, "emailconfirm", data.message);
					} else {
						markValidElement(box_Email);
						markValidElement(box_EmailConfirm);
					}
				
				}, "json"
			);
}

function clearEmailsMarks() {
	$("#FR_ErrorMSG_email").remove();
	$("#FR_ErrorMSG_emailconfirm").remove();
	box_Email.css("border", BorderCSS);
	box_EmailConfirm.css("border", BorderCSS);
}

function passwordStrengthMeterImg(password)
{
        var desc = new Array();
        desc[0] = "images/ajaxreg/rating/1.gif";
        desc[1] = "images/ajaxreg/rating/2.gif";
        desc[2] = "images/ajaxreg/rating/3.gif";
        desc[3] = "images/ajaxreg/rating/4.gif";
        desc[4] = "images/ajaxreg/rating/5.gif";
        desc[5] = "images/ajaxreg/rating/6.gif";
		
		if(password.length < 5) {
			return(desc[0]);
		}

        var score   = 0;

        //if password bigger than 6 give 1 point
        if (password.length > 6) score++;

        //if password has both lower and uppercase characters give 1 point      
        if ( ( password.match(/[a-z]/) ) && ( password.match(/[A-Z]/) ) ) score++;

        //if password has at least one number give 1 point
        if (password.match(/\d+/)) score++;

        //if password has at least one special caracther give 1 point
        if ( password.match(/.[!,@,#,$,%,^,&,*,?,_,~,-,(,)]/) ) score++;

        //if password bigger than 12 give another 1 point
        if (password.length > 12) score++;
		return(desc[score]);
}